
/*!
 * jade-serial
 * Copyright (c) 2011 LearnBoost <dev@learnboost.com>
 * MIT Licensed
 */

/**
 * Module dependencies.
 */

var jade = require('jade')
  , Parser = jade.Parser
  , Serializer = require('./serializer')
  , Deserializer = require('./deserializer');

/**
 * Serialize the given `str` of Jade.
 *
 * @param {String|Object} str
 * @return {Object}
 * @api public
 */

exports.serialize = function(str){
  var ast = 'object' == typeof str
    ? str
    : new Parser(str).parse();
  return new Serializer(ast).serialize();
};

/**
 * Deserialize a JSON-friendly serialized `obj` representing
 * a Jade AST.
 *
 * @param {Object} obj
 * @return {Node}
 * @api public
 */

exports.deserialize = function(obj){
  return new Deserializer(obj).deserialize();
};
